chiark / gitweb /
tests: gitrepo-edit: seems to work
[dgit.git] / dgit-repos-server
index 2cbb4e7d449469485db35fc828c494ccd38e3181..ad4cde561c391a0e5b780dcacef8033227d4c588 100755 (executable)
@@ -86,6 +86,8 @@ use POSIX;
 use Fcntl qw(:flock);
 use File::Path qw(rmtree);
 
+open DEBUG, ">/dev/null" or die $!;
+
 our $package_re = '[0-9a-z][-+.0-9a-z]+';
 
 our $func;
@@ -97,19 +99,26 @@ our $destrepo;
 our $workrepo;
 our $keyrings;
 our @lockfhs;
+our $debug='';
 
 #----- utilities -----
 
+sub debug {
+    print DEBUG "$debug @_\n";
+}
+
 sub acquirelock ($$) {
     my ($lock, $must) = @_;
     my $fh;
+    printf DEBUG "$debug locking %s %d\n", $lock, $must;
     for (;;) {
        close $fh if $fh;
        $fh = new IO::File $lock, ">" or die "open $lock: $!";
        my $ok = flock $fh, $must ? LOCK_EX : (LOCK_EX|LOCK_NB);
        if (!$ok) {
-           return undef unless $must;
-           die "flock $lock: $!";
+           die "flock $lock: $!" if $must;
+           debug " locking $lock failed";
+           return undef;
        }
        if (!stat $lock) {
            next if $! == ENOENT;
@@ -133,11 +142,43 @@ sub acquiretree ($$) {
     return $fh;
 }
 
+sub mkrepotmp () {
+    my $tmpdir = "$dgitrepos/_tmp";
+    return if mkdir $tmpdir;
+    return if $! == EEXIST;
+    die $!;
+}
+
+sub recorderror ($) {
+    my ($why) = @_;
+    my $w = $ENV{'DGIT_DRS_WORK'}; # we are in stunthook
+    if (defined $w) {
+       chomp $why;
+       open ERR, ">", "$w/drs-error" or die $!;
+       print ERR $why, "\n" or die $!;
+       close ERR or die $!;
+       return 1;
+    }
+    return 0;
+}
+
 sub reject ($) {
-    die "dgit-repos-server: reject: $_[0]\n";
+    my ($why) = @_;
+    recorderror "reject: $why";
+    die "dgit-repos-server: reject: $why\n";
+}
+
+sub debugcmd {
+    if ($debug) {
+       use Data::Dumper;
+       local $Data::Dumper::Indent = 0;
+       local $Data::Dumper::Terse = 1;
+       debug "|".Dumper(\@_);
+    }
 }
 
 sub runcmd {
+    debugcmd @_;
     $!=0; $?=0;
     my $r = system @_;
     die "@_ $? $!" if $r;
@@ -146,13 +187,17 @@ sub runcmd {
 #----- git-receive-pack -----
 
 sub fixmissing__git_receive_pack () {
+    mkrepotmp();
     $destrepo = "$dgitrepos/_tmp/${package}_prospective";
     acquiretree($destrepo, 1);
-    my $r = system qw(cp -a --), "$dgitrepos/_template", "$destrepo";
+    my $template = "$dgitrepos/_template";
+    debug "fixmissing copy tempalate $template -> $destrepo";
+    my $r = system qw(cp -a --), $template, $destrepo;
     !$r or die "create new repo failed failed: $r $!";
 }
 
 sub makeworkingclone () {
+    mkrepotmp();
     $workrepo = "$dgitrepos/_tmp/${package}_incoming$$";
     acquiretree($workrepo, 1);
     runcmd qw(git clone -l -q --mirror), $destrepo, $workrepo;
@@ -168,13 +213,26 @@ set -e
 exec $0 --pre-receive-hook $package
 END
     close $fh or die "$prerecv: $!";
-    $ENV{'DGIT_RPR_WORK'}= $workrepo;
-    $ENV{'DGIT_RPR_DEST'}= $destrepo;
+    $ENV{'DGIT_DRS_WORK'}= $workrepo;
+    $ENV{'DGIT_DRS_DEST'}= $destrepo;
+    debug " stunt hook set up $prerecv";
 }
 
 sub maybeinstallprospective () {
     return if $destrepo eq $realdestrepo;
 
+    if (open REJ, "<", "$workrepo/drs-error") {
+       local $/ = undef;
+       my $msg = <REJ>;
+       REJ->error and die $!;
+       print STDERR $msg;
+       exit 1;
+    } else {
+       $!==&ENOENT or die $!;
+    }
+
+    debug " show-ref ($destrepo) ...";
+
     my $child = open SR, "-|";
     defined $child or die $!;
     if (!$child) {
@@ -185,6 +243,7 @@ sub maybeinstallprospective () {
     my %got = qw(tag 0 head 0);
     while (<SR>) {
        chomp or die;
+       debug " show-refs| $_";
        s/^\S*[1-9a-f]\S* (\S+)$/$1/ or die;
        my $wh =
            m{^refs/tags/} ? 'tag' :
@@ -192,9 +251,13 @@ sub maybeinstallprospective () {
            die;
        die if $got{$wh}++;
     }
-    die if grep { !$_ } values %got;
-    $!=0; $?=0; close SR or die "$? $!";
+    $!=0; $?=0; close SR or $?==256 or die "$? $!";
+
+    debug "installprospective ?";
+    die Dumper(\%got)." -- missing refs in new repo"
+       if grep { !$_ } values %got;
 
+    debug "install $destrepo => $realdestrepo";
     rename $destrepo, $realdestrepo or die $!;
     remove "$destrepo.lock" or die $!;
 }
@@ -202,7 +265,7 @@ sub maybeinstallprospective () {
 sub main__git_receive_pack () {
     makeworkingclone();
     setupstunthook();
-    runcmd qw(git receive-pack), $destrepo;
+    runcmd qw(git receive-pack), $workrepo;
     maybeinstallprospective();
 }
 
@@ -212,7 +275,10 @@ our ($tagname, $tagval, $suite, $oldcommit, $commit);
 our ($version, %tagh);
 
 sub readupdates () {
+    debug " updates ...";
     while (<STDIN>) {
+       chomp or die;
+       debug " upd.| $_";
        m/^(\S+) (\S+) (\S+)$/ or die "$_ ?";
        my ($old, $sha1, $refname) = ($1, $2, $3);
        if ($refname =~ m{^refs/tags/(?=debian/)}) {
@@ -235,9 +301,11 @@ sub readupdates () {
 
     die unless defined $tagname;
     die unless defined $suite;
+    debug " updates ok.";
 }
 
 sub parsetag () {
+    debug " parsetag...";
     open PT, ">dgit-tmp/plaintext" or die $!;
     open DS, ">dgit-tmp/plaintext.asc" or die $!;
     open T, "-|", qw(git cat-file tag), $tagval or die $!;
@@ -253,11 +321,12 @@ sub parsetag () {
        }
     }
     $!=0; $_=<T>; defined or die $!;
-    m/^($package_re) release (\S+) for (\S+) \[dgit\]$/ or die;
+    m/^($package_re) release (\S+) for \S+ \((\S+)\) \[dgit\]$/ or
+       reject "tag message not in expected format";
 
     die unless $1 eq $package;
     $version = $2;
-    die unless $3 eq $suite;
+    die "$3 != $suite " unless $3 eq $suite;
 
     for (;;) {
        print PT or die $!;
@@ -272,6 +341,7 @@ sub parsetag () {
     T->error and die $!;
     close PT or die $!;
     close DS or die $!;
+    debug " parsetag ok.";
 }
 
 sub checksig_keyring ($) {
@@ -282,14 +352,20 @@ sub checksig_keyring ($) {
 
     my $ok = undef;
 
-    open P, "-|", (qw(gpgv --status-fd=1 --keyring),
+    debug " checksig keyring $keyringfile...";
+
+    our @cmd = (qw(gpgv --status-fd=1 --keyring),
                   $keyringfile,
-                  qw(dgit-tmp/plaintext.asc dgit-tmp/plaintext))
+                  qw(dgit-tmp/plaintext.asc dgit-tmp/plaintext));
+    debugcmd @cmd;
+
+    open P, "-|", @cmd
        or die $!;
 
     while (<P>) {
-       next unless s/^\[GNUPG:\]: //;
+       next unless s/^\[GNUPG:\] //;
        chomp or die;
+       debug " checksig| $_";
        my @l = split / /, $_;
        if ($l[0] eq 'NO_PUBKEY') {
            last;
@@ -303,11 +379,14 @@ sub checksig_keyring ($) {
     }
     close P;
 
+    debug sprintf " checksig ok=%d", !!$ok;
+
     return $ok;
 }
 
 sub dm_txt_check ($$) {
     my ($keyid, $dmtxtfn) = @_;
+    debug " dm_txt_check $keyid $dmtxtfn";
     open DT, '<', $dmtxtfn or die "$dmtxtfn $!";
     while (<DT>) {
        m/^fingerprint:\s+$keyid$/oi
@@ -322,8 +401,14 @@ sub dm_txt_check ($$) {
        # in allow field...
        s/\([^()]+\)//;
        s/\,//;
+       chomp or die;
+       debug " dm_txt_check allow| $_";
        foreach my $p (split /\s+/) {
-           return if $p eq $package; # yay!
+           if ($p eq $package) {
+               # yay!
+               debug " dm_txt_check ok";
+               return;
+           }
        }
     }
     DT->error and die $!;
@@ -333,13 +418,16 @@ sub dm_txt_check ($$) {
 
 sub verifytag () {
     foreach my $kas (split /:/, $keyrings) {
+       debug "verifytag $kas...";
        $kas =~ s/^([^,]+),// or die;
        my $keyid = checksig_keyring $1;
        if (defined $keyid) {
            if ($kas =~ m/^a$/) {
+               debug "verifytag a ok";
                return; # yay
            } elsif ($kas =~ m/^m([^,]+)$/) {
                dm_txt_check($keyid, $1);
+               debug "verifytag m ok";
                return;
            } else {
                die;
@@ -350,6 +438,7 @@ sub verifytag () {
 }
 
 sub checksuite () {
+    debug "checksuite ($suitesfile)";
     open SUITES, "<", $suitesfile or die $!;
     while (<SUITES>) {
        chomp;
@@ -362,7 +451,16 @@ sub checksuite () {
     reject "unknown suite";
 }
 
+sub tagh1 ($) {
+    my ($tag) = @_;
+    my $vals = $tagh{$tag};
+    reject "missing tag $tag in signed tag object" unless $vals;
+    reject "multiple tags $tag in signed tag object" unless @$vals == 1;
+    return $vals->[0];
+}
+
 sub checks () {
+    debug "checks";
     checksuite();
     tagh1('type') eq 'commit' or die;
     tagh1('object') eq $commit or die;
@@ -370,9 +468,12 @@ sub checks () {
 
     my $v = $version;
     $v =~ y/~:/_%/;
+
+    debug "translated version $v";
     $tagname eq "debian/$v" or die;
 
     # check that our ref is being fast-forwarded
+    debug "oldcommit $oldcommit";
     if ($oldcommit =~ m/[^0]/) {
        $?=0; $!=0; my $mb = `git merge-base $commit $oldcommit`;
        chomp $mb;
@@ -381,15 +482,17 @@ sub checks () {
 }
 
 sub onwardpush () {
+    my @cmd = (qw(git send-pack), $destrepo,
+              "$commit:refs/dgit/$suite",
+              "$tagval:refs/tags/$tagname");
+    debugcmd @cmd;
     $!=0;
-    my $r = system (qw(git send-pack),
-                   $destrepo,
-                   "$commit:refs/dgit/$suite",
-                   "$tagval:refs/tags/$tagname");
+    my $r = system @cmd;
     !$r or die "onward push failed: $r $!";
 }      
 
 sub stunthook () {
+    debug "stunthook";
     chdir $workrepo or die "chdir $workrepo: $!";
     mkdir "dgit-tmp" or $!==EEXIST or die $!;
     readupdates();
@@ -397,6 +500,7 @@ sub stunthook () {
     verifytag();
     checks();
     onwardpush();
+    debug "stunthook done.";
 }
 
 #----- git-upload-pack -----
@@ -430,21 +534,36 @@ sub argval () {
 sub parseargsdispatch () {
     die unless @ARGV;
 
+    delete $ENV{'GIT_DIR'}; # if not run via ssh, our parent git process
+    delete $ENV{'GIT_PREFIX'}; # sets these and they mess things up
+
+    if ($ENV{'DGIT_DRS_DEBUG'}) {
+       $debug='=';
+       open DEBUG, ">&STDERR" or die $!;
+    }
+
     if ($ARGV[0] eq '--pre-receive-hook') {
+       if ($debug) { $debug.="="; }
        shift @ARGV;
        @ARGV == 1 or die;
        $package = shift @ARGV;
-       defined($suitesfile = $ENV{'DGIT_RPR_SUITES'}) or die;
-       defined($workrepo = $ENV{'DGIT_RPR_WORK'}) or die;
-       defined($destrepo = $ENV{'DGIT_RPR_DEST'}) or die;
-       defined($keyrings = $ENV{'DGIT_RPR_KEYRINGS'}) or die $!;
+       defined($suitesfile = $ENV{'DGIT_DRS_SUITES'}) or die;
+       defined($workrepo = $ENV{'DGIT_DRS_WORK'}) or die;
+       defined($destrepo = $ENV{'DGIT_DRS_DEST'}) or die;
+       defined($keyrings = $ENV{'DGIT_DRS_KEYRINGS'}) or die $!;
        open STDOUT, ">&STDERR" or die $!;
-       stunthook();
+       eval {
+           stunthook();
+       };
+       if ($@) {
+           recorderror "$@" or die;
+           die $@;
+       }
        exit 0;
     }
 
-    $ENV{'DGIT_RPR_SUITES'} = argval();
-    $ENV{'DGIT_RPR_KEYRINGS'} = argval();
+    $ENV{'DGIT_DRS_SUITES'} = argval();
+    $ENV{'DGIT_DRS_KEYRINGS'} = argval();
     $dgitrepos = argval();
 
     die unless @ARGV==1 && $ARGV[0] eq '--ssh';
@@ -474,10 +593,12 @@ sub parseargsdispatch () {
        $destrepo = $realdestrepo;
     } else {
        $! == ENOENT or die "stat dest repo $destrepo: $!";
+       debug " fixmissing $funcn";
        my $fixfunc = $main::{"fixmissing__$funcn"};
        &$fixfunc;
     }
 
+    debug " running main $funcn";
     &$mainfunc;
 }
 
@@ -487,7 +608,10 @@ sub unlockall () {
 
 sub cleanup () {
     unlockall();
-    chdir "$dgitrepos/_tmp" or die $!;
+    if (!chdir "$dgitrepos/_tmp") {
+       $!==ENOENT or die $!;
+       return;
+    }
     foreach my $lf (<*.lock>) {
        my $tree = $lf;
        $tree =~ s/\.lock$//;